/*
ID: espr1t
TASK: Closest Points
KEYWORDS: Slow solution
*/

#include <cstdio>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;
FILE* in = stdin; FILE* out = stdout;

const int MAX = 100000;
const int DIM = 5;
const long long INF = 1000000000000000001LL;

long long sqr(long long a) {
    return a * a;
}

int n, k, q;
int a[MAX][DIM], b[MAX][DIM];

void solve() {
    for (int i = 0; i < q; i++) {
        long long minn = INF;
        for (int c = 0; c < n; c++) {
            long long cur = 0;
            for (int dim = 0; dim < k; dim++)
                cur += sqr(a[c][dim] - b[i][dim]);
            minn = min(minn, cur);
        }
        fprintf(out, "%.3lf\n", sqrt((double)minn));
    }
}

void readInput() {
    fscanf(in, "%d %d", &n, &k);
    for (int i = 0; i < n; i++)
        for (int c = 0; c < k; c++)
            fscanf(in, "%d", &a[i][c]);
    fscanf(in, "%d", &q);
    for (int i = 0; i < q; i++)
        for (int c = 0; c < k; c++)
            fscanf(in, "%d", &b[i][c]);
}

int main(void) {
//    in = fopen("ClosestPoints.in", "rt"); //out = fopen("ClosestPoints.out", "wt");
    
    readInput();
    solve();
    
    return 0;
}
